/*
This program has been developed by students from the bachelor Computer Science at Utrecht University within the Software Project course.
© Copyright Utrecht University (Department of Information and Computing Sciences)
*/

package consume

import "query-service/internal/entity"

/*
getHeaders retrieves the headers from the message
	headers: *map[string]interface{}, the headers from the message
	Return: (*string, *string, *string, error), the headers to be retrieved and a potential error
*/
func getHeaders(headers *map[string]interface{}) (*string, *string, *string, error) {
	sessionID, ok := (*headers)["sessionID"].(string)
	if !ok {
		return nil, nil, nil, entity.NewError("missing sessionID in header", entity.MessageHeaderError)
	}

	clientID, ok := (*headers)["clientID"].(string)
	if !ok {
		return nil, nil, nil, entity.NewError("missing clientID in header", entity.MessageHeaderError)
	}

	var queryID string
	queryID, ok = (*headers)["queryID"].(string)
	if !ok {
		return nil, nil, nil, entity.NewError("missing queryID in header", entity.MessageHeaderError)
	}

	return &sessionID, &clientID, &queryID, nil
}
