/*
This program has been developed by students from the bachelor Computer Science at Utrecht University within the Software Project course.
© Copyright Utrecht University (Department of Information and Computing Sciences)
*/

package consume

import (
	"encoding/json"
	"query-service/internal/entity"
)

/*
This function published the error
	sessionID: *string, the ID of the session,
	queryID: *string, the ID of the query,
	errorCode: entity.ErrorCode, the error code of the error,
	reason: string, the reason of the error
*/
func (s *Service) publishError(sessionID *string, queryID *string, errorCode entity.ErrorCode, reason string) {
	errorMsg := entity.ErrorMessage{
		Type:    "query_error",
		QueryID: *queryID,
		Code:    int(errorCode),
		Value:   reason,
	}
	errorMsgBytes, _ := json.Marshal(errorMsg)
	s.producer.PublishMessage(&errorMsgBytes, sessionID)
	return
}
